Subject: Re: bug#46195: [PATCH] Add julia-http with dependencies
From: Ludovic Courtès <[email-masked]>
To: Nicolò Balzarotti <[email-masked]>
Cc: [email-masked]
Date: Sat, 20 Mar 2021 22:32:50 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi Nicolò,

Nicolò Balzarotti <[email-masked]> skribis:

> This time one package (julia-mbedtls-jll) requires a shared library
> (mbedtls-apache).  The most recent way (threre has been a few during the
> years) Julia packages use to ship binaries is by using jllwrappers
> [fn:1], which generates package_jll (e.g. mbedtls-jll [fn:2]), a Julia
> package which is then included by the real Julia package (e.g. mbedtls
> [fn:3]).  Jllwrappers usually downloads prebuild binaries.  There's an
> override mechanism (creating a folder named "override" under the julia
> module dir).

So JLL is a “foreign function interface” (FFI), right?

> They recently added an easiesr way to override this behaviour
> (https://github.com/JuliaPackaging/JLLWrappers.jl/pull/27), but this
> will be available on julia 1.6+.
>
> In the meanwhile I see two ways around this:
> - symlinking deps into
>   /gnu/store/...julia-packagename-jll/[...]/override
> - patching both jllwrappers to support a custom override path, and then
>   patching the jllwrapper call inside each package-jll so that the
>   library/binary is searched in the correct directory.
>
> I do like this second approach more (but I don't have a strong opinion
> on this), so in this patchset I patched @generate_wrapper_header macro,
> so that it takes an optional parameter with the overidden library path.
> While we wait for julia 1.6, the way to use this is (like I'm doing in
> mbedtls-jll) to add the path to the library the generate_wrapper_header
> call, and everything works fine.  I also added the relative
> documentation.  If you think symlinking is a better approach, let me
> know so that I can update this patch set.

Sounds reasonable to me.

I pushed the whole series, tweaking one or two commit logs; I also took
the liberty to adjust this example:

> +The package @code{MbetTLS} can be taken as an example:
> +@lisp
> +(add-after 'unpack 'override-binary-path
> +           (lambda* (#:key inputs #:allow-other-keys)
> +             (map
> +              (lambda (wrapper)
> +                (substitute* wrapper
> +                  (("generate_wrapper_header.*")
> +                   (string-append
> +                    "generate_wrapper_header(\"MbedTLS\", \""
> +                    (assoc-ref inputs "mbedtls-apache") "\")\n"))))
> +              ;; There's a Julia file for each platform, override them all
> +              (find-files "src/wrappers/" "\\.jl$"))
> +             #t))
> +@end lisp

… where I “fixed” indentation, used ‘for-each’ instead of ‘map’, and
removed the trailing #t (it’s obsolescent).

Thank you, and apologies for the delay!

Ludo’.